#!/usr/bin/perl

local($seqfile);
local($choix);
local($al_val);
local($alpha_file);
local(*ALPHA_FILE);
local($n_alpha);
local($i);
local($interleaved);
local($line);
local($tstv);
local(@alpha);
local($_WIN);

$_WIN = 0;

$seqfile = "infile";
while((-e $seqfile) eq "")
  {
    print "DNAphylip.pl : can't find input file \"$seqfile\"\n";
    print "Please enter a new file name> ";
    $seqfile = <STDIN>;
    chomp($seqfile);
  }



$al_val      = "default";
$model       = "F84";
$choix       = "Z";
$interleaved = "Yes";
$tstv        = "2";


while(($choix ne "Y") && ($choix ne "y"))
  {
    if(!$_WIN)
      {
	printf("\033[2J\033[H");
      }
    else
      {
	system "cls\n";
      }


    printf(" **********************************************************************\n");
    printf(" DNAphylip.pl : a Perl script based on  PHYLIP  3.6a2  DNADIST  program \n");
    printf(" Felsenstein, J. 1989. PHYLIP Phylogeny Inference Package (Version3.2). \n");
    printf(" Cladistics. 5:164-166\n");
    printf(" **********************************************************************\n");

    printf("\n\n\n");

    printf(" V  Values of alpha (default/user defined)?  %s\n",$al_val);
    printf(" D    Distance (F84, Kimura, Jukes-Cantor)?  %s\n",$model);
    if($model ne "Jukes-Cantor")
      {
	printf(" T           Transition/transversion ratio?  %.2f\n",$tstv);
      }
    printf(" I             Input sequences interleaved?  %s\n",$interleaved);
    printf("\n Are these settings correct? (type Y or the letter for one to change)\n ");


    $choix = <STDIN>;
    chomp($choix);

    if(($choix eq "V") || ($choix eq "v"))
      {
        if($al_val eq "default")
          {
            print " Name of the file which contains your values of alpha : ";
            $alpha_file = <STDIN>;
            chomp($alpha_file);
            while((-e $alpha_file) eq "")
              {
                print " Can't find input file \"$alpha_file\"\n";
                print " Please enter a new file name> ";
                $alpha_file = <STDIN>;
                chomp($alpha_file);
              }
            $al_val = "user defined";
          }
      }

    if(($choix eq "D") || ($choix eq "d"))
      {
        if($model eq "F84")
          {
            $model = "Kimura";
          }
        else
          {
            if($model eq "Kimura")
              {
                $model = "Jukes-Cantor";
              }
            else
              {
                $model = "F84";
              }
          }
      }
    
    if(($choix eq "T") || ($choix eq "t"))
      {
	
	printf(" Transition/transversion ratio? ");
	$tstv = <STDIN>;
	chomp($tstv);
	while($tstv < .0)
	  {
	    printf(" Ts/Tv should be a positive number\n");
	    printf(" Please enter a new value : ");
	    $tstv = <STDIN>;
	    chomp($tstv);
	  }
      }

    if(($choix eq "I") || ($choix eq "i"))
      {
        if($interleaved eq "Yes")
          {
            $interleaved = "No, sequential";
          }
        else
          {
            $interleaved = "Yes";
          }
      }
  }

if($al_val eq "user defined")
  {
    open(ALPHA_FILE,$alpha_file) || die;
    $i=0;
    while($line = <ALPHA_FILE>)
      {
        chomp($line);
        $alpha[$i] = $line;
        $i++;
      }
    close(ALPHA_FILE);
    $n_alpha = $i;
    printf(" %d matrices to check\n",$n_alpha);
  }
else
  {
    $val = 0.06;
    for($i=0;$i<147;$i++)
      {
	$alpha[$i] = $val;
	$val += .02;
      }
    
    for($i=147;$i<217;$i++)
      {
	$alpha[$i] = $val;
	$val += 0.1;
      }
    
    $alpha[217] = 50.0;
    $alpha[218] = 100.0;
    $alpha[219] = 500.0;
    $alpha[220] = 1000.0;
    $alpha[221] = 5000.0;

    $n_alpha = 222;
    printf(" %d matrices to check\n",$n_alpha);
  }

if(!$n_alpha) {exit;}
print " dnadist is running...\n";
unlink("all_dists");
open(FILE,">all_dists");
close(FILE);
for($i=0;$i<$n_alpha;$i++)
  {
    printf(" [%3d/%3d]\n",$i+1,$n_alpha);
    unlink("outfile");
    open(DNADIST,"| dnadist > null");
    if ($seqfile ne "infile"){print DNADIST "$seqfile\n";}
    if($model eq "Kimura")
      {
        print DNADIST "D\n";
      }
    else
      {
        if($model eq "Jukes-Cantor")
          {
            print DNADIST "D\n";
            print DNADIST "D\n";
          }
      }

    if(($tstv != 2.0) && ($model ne "Jukes-Cantor"))
      {
	print DNADIST "T\n";
	print DNADIST "$tstv\n";	
      }

    print DNADIST "G\n";

    if($interleaved eq "No, sequential")
      {
        print DNADIST "I\n";
      }

    print DNADIST "Y\n";
    $coeff = 1./sqrt($alpha[$i]);
    print DNADIST "$coeff\n";
    close(DNADIST);
    if(!$_WIN)
      {
	system("cat outfile >> all_dists");
      }
    else
      {
	system("COPY all_dists+outfile all_dists > null");
      }
    unlink("null")
  }

unlink("outfile");
