#!/usr/bin/perl

local($seqfile);
local($choix);
local($al_val);
local($alpha_file);
local(*ALPHA_FILE);
local($n_alpha);
local($i);
local($interleaved);
local($line);
local(@alpha);
local($_WIN);

$_WIN = 0;

$seqfile = "infile";
while((-e $seqfile) eq "")
  {
    print "PROTphylip.pl: can't find input file \"$seqfile\"\n";
    print "Please enter a new file name> ";
    $seqfile = <STDIN>;
    chomp($seqfile);
  }



$al_val      = "default";
$model       = "Jones-Taylor-Thornton matrix";
$choix       = "Z";
$interleaved = "Yes";
$geneticc    = "Universal";
$cataa       = "Chemical";


while(($choix ne "Y") && ($choix ne "y"))
  {

    if(!$_WIN)
      {
	printf("\033[2J\033[H");
      }
    else
      {
	system "cls\n";
      }

    

    printf(" **********************************************************************\n");
    printf(" PROTphylip.pl : a  Perl script  based on PHYLIP 3.6a2 PROTDIST program\n");
    printf(" Felsenstein, J. 1989. PHYLIP Phylogeny Inference Package (Version3.2).\n");
    printf(" Cladistics. 5:164-166\n");
    printf(" **********************************************************************\n");

    printf("\n\n");
    printf(" **********************************************************************\n");
    printf(" It seems  that in many  data sets distances between  protein sequences\n");
    printf(" can't be computed with low  values of alpha (i.e.  strong variation of\n");
    printf(" substitution rates among sites) .  We recommend to check the distances\n");
    printf(" computed  and   eventually  restart  the  computation   using  a  file\n");
    printf(" containing high values (i.e. > 5) of the gamma shape parameter.\n");
    printf(" **********************************************************************\n");



    printf("\n\n\n");

    printf(" V   Values of alpha (default/user defined)?  %s\n",$al_val);
    printf(" P         Use JTT, PAM or categories model?  %s\n",$model);
    if($model eq "Categories model")
      {
    printf(" U                  Use which  genetic code?  %s\n",$geneticc);
    printf(" A    Which  categorization  of amino acids?  %s\n",$cataa);
      }
    printf(" I              Input sequences interleaved?  %s\n",$interleaved);
    printf("\n Are these settings correct? (type Y or the letter for one to change)\n ");


    $choix = <STDIN>;
    chomp($choix);

    if(($choix eq "V") || ($choix eq "v"))
      {
        if($al_val eq "default")
          {
            print " Name of the file which contains your values of alpha : ";
            $alpha_file = <STDIN>;
            chomp($alpha_file);
            while((-e $alpha_file) eq "")
              {
                print " Can't find input file \"$alpha_file\"\n";
                print " Please enter a new file name> ";
                $alpha_file = <STDIN>;
                chomp($alpha_file);
              }
            $al_val = "user defined";
          }
      }

    if(($choix eq "P") || ($choix eq "p"))
      {
        if($model eq "Jones-Taylor-Thornton matrix")
          {
            $model = "Dayhoff PAM matrix";
          }
        else
          {
            if($model eq "Dayhoff PAM matrix")
              {
		$model = "Categories model";
              }
	    else
	      {
		if($model eq "Categories model")
		  {
		    $model = "Jones-Taylor-Thornton matrix";
		  }
	      }
	  }
      }

    if($model eq "Categories model")
      {
	if(($choix eq "U") || ($choix eq "u"))
	  {
	    do
	      {
		printf(" Which genetic code?\n");
		printf(" type         for\n");
		printf("  U           Universal\n");
		printf("  M           Mitochondrial\n");
		printf("  V           Vertebrate mitochondrial\n");
		printf("  F           Fly mitochondrial\n");
		printf("  Y           Yeast mitochondrial\n\n-> ");
		$choixcode = <STDIN>;
		chomp($choixcode);
	      }while(($choixcode ne "U") &&
		     ($choixcode ne "u") &&
		     ($choixcode ne "M") &&
		     ($choixcode ne "m") &&
		     ($choixcode ne "V") &&
		     ($choixcode ne "v") &&
		     ($choixcode ne "F") &&
		     ($choixcode ne "f") &&
		     ($choixcode ne "Y") &&
		     ($choixcode ne "y"));
	    if(($choixcode eq "U") || ($choixcode eq "u"))
	      {
		$geneticc = "Universal";
	      }
	    if(($choixcode eq "M") || ($choixcode eq "m"))
	      {
		$geneticc = "Mitochondrial";
	      }
	    if(($choixcode eq "V") || ($choixcode eq "v"))
	      {
		$geneticc = "Vertebrate mitochondrial";
	      }
	    if(($choixcode eq "F") || ($choixcode eq "f"))
	      {
		$geneticc = "Fly mitochondrial";
	      }
	    if(($choixcode eq "Y") || ($choixcode eq "y"))
	      {
		$geneticc = "Yeast mitochondrial";
	      }
	  }
	if(($choix eq "A") || ($choix eq "a"))
	  {
	    do
	      {
		printf(" Which categorizations of amino acids do you want to use:\n");
		printf(" G  George/Hunt/Barker\n");
		printf(" C  Chemical\n");
		printf(" H  Hall\n\n-> ");
		$choixcat = <STDIN>;
		chomp($choixcat);
		}
		while(($choixcat ne "G") &&
		      ($choixcat ne "g") &&
		      ($choixcat ne "C") &&
		      ($choixcat ne "c") &&
		      ($choixcat ne "H") &&
		      ($choixcat ne "h"));
	    if(($choixcat eq "G") || ($choixcat eq "g"))
	      {
		$cataa = "George/Hunt/Barker";
	      }
	    if(($choixcat eq "C") || ($choixcat eq "c"))
	      {
		$cataa = "Chemical";
	      }
	    if(($choixcat eq "H") || ($choixcat eq "h"))
	      {
		$cataa = "Hall";
	      }
	  }
      }

    if(($choix eq "I") || ($choix eq "i"))
      {
        if($interleaved eq "Yes")
          {
            $interleaved = "No";
          }
        else
          {
            $interleaved = "Yes";
          }
      }
  }

if($al_val eq "user defined")
  {
    open(ALPHA_FILE,$alpha_file) || die;
    $i=0;
    while($line = <ALPHA_FILE>)
      {
        chomp($line);
        $alpha[$i] = $line;
        $i++;
      }
    close(ALPHA_FILE);
    $n_alpha = $i;
    printf(" %d matrices to check\n",$n_alpha);
  }
else
  {
    $val = 0.06;
    for($i=0;$i<147;$i++)
      {
	$alpha[$i] = $val;
	$val += .02;
      }
    
    for($i=147;$i<217;$i++)
      {
	$alpha[$i] = $val;
	$val += 0.1;
      }
    
    $alpha[217] = 50.0;
    $alpha[218] = 100.0;
    $alpha[219] = 500.0;
    $alpha[220] = 1000.0;
    $alpha[221] = 5000.0;

    $n_alpha = 222;
    printf(" %d matrices to check\n",$n_alpha);
  }

if(!$n_alpha) {exit;}
print " protdist is running...\n";
unlink("all_dists");
open(FILE,">all_dists");
close(FILE);
for($i=0;$i<$n_alpha;$i++)
  {
    printf(" [%3d/%3d]\n",$i+1,$n_alpha);
    unlink("outfile");
    open(PROTDIST,"| protdist > null");
    if ($seqfile ne "infile"){print PROTDIST "$seqfile\n";}
    if($model eq "Dayhoff PAM matrix")
      {
        print PROTDIST "P\n";
      }
    else
      {
        if($model eq "Categories model")
          {
            print PROTDIST "P\n";
            print PROTDIST "P\n";
            print PROTDIST "P\n";
            print PROTDIST "P\n";
	    
	    if($geneticc eq "Mitochondrial")
	      {
		print PROTDIST "U\n";
		print PROTDIST "M\n";
	      }
	    if($geneticc eq "Vertebrate mitochondrial")
	      {
		print PROTDIST "U\n";
		print PROTDIST "V\n";
	      }
	    if($geneticc eq "Fly mitochondrial")
	      {
		print PROTDIST "U\n";
		print PROTDIST "F\n";
	      }
	    if($geneticc eq "Yeast mitochondrial")
	      {
		print PROTDIST "U\n";
		print PROTDIST "Y\n";
	      }

	    if($cataa eq "George/Hunt/Barker")
	      {
		print PROTDIST "A\n";
		print PROTDIST "G\n";
	      }
	    if($cataa eq "Hall")
	      {
		print PROTDIST "A\n";
		print PROTDIST "H\n";
	      }
	  }
      	}

    print PROTDIST "G\n";

    if($interleaved eq "No")
      {
        print PROTDIST "I\n";
      }

    print PROTDIST "Y\n";
    $coeff = 1./sqrt($alpha[$i]);
    print PROTDIST "$coeff\n";
    close(PROTDIST);
    if(!$_WIN)
      {
	system("cat outfile >> all_dists");
      }
    else
      {
	system("COPY all_dists+outfile all_dists > null");
      }
    unlink("null")
  }

unlink("outfile");
