#include "Generic.h"
#include "Additiv.h"
#include "Bionj.h"


 
/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


double Q_Add_Topo(arbre *tree, matrix *mat)
{
  double add,Wsum;


  add = Wsum = 0.0;

  tree->n_branch_neg=0;

  M_Order(tree->noeuds,mat);

  if(!(tree->noeuds[0]->sons))
    M_Sons(tree->noeuds,tree->n_otu);
  R_Additiv(tree->noeuds[0],tree->noeuds[0]->v[0],mat,tree);
  Print_Val(tree->noeuds[0],tree->noeuds[0]->v[0],&add,&Wsum,(int)tree->n_otu);

  return (add)*(1./(tree->n_otu-3-tree->n_branch_neg));
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void R_Additiv(node *pere, node *fils, matrix *mat, arbre *tree)
{

  int i,j;
  int dir_fils,dir1,dir2;
  int P1,P2;
  double T1, T2, T3, T4, T5, T6;
  int n_otu;
  double *d_sums;
  double first_t,sec_t,third_t;

  dir_fils = dir1 = dir2 = -1;
  T1 = T2 = T3 = T4 = T5 = T6 = 0.0;

  n_otu = mat->n_spec;

 if(fils->num < n_otu) return;

  if(pere->num < n_otu)
    {
      For(i,3)
	{
	  if(fils->v[i] != pere)
	    R_Additiv(fils,fils->v[i],mat,tree);
	}
    }

  else
    {
      For(i,3)
	if(pere->v[i] == fils)
	  {
	    dir_fils = i;
	    break;
	  }

      if(pere->l[dir_fils] < .0)
	{
	  tree->n_branch_neg++;
	}

      else
	{
	  
	  P1 = P2 = 0 ;
	  
	  
	  For(i,3)
	    {
	      if(pere->v[i] != fils)
		{
		  if(!P1)
		    {
		      P1 = 1;
		      For(j,3)
			{
			  if(fils->v[j] != pere)
			    {
			      if(!P2)
				{
				  P2 = 1;
				  T1 = M_Additiv(mat,pere,fils,i,j); 
				}
			      else    
				T2 = M_Additiv(mat,pere,fils,i,j);		    
			    }
			}
		      P2 = 0;
		      
		      For(j,3)
			if(pere->v[j] != fils && j != i)
			  T3 = M_Additiv(mat,pere,pere,i,j);
		      
		    }
		  
		  else
		    {
		      For(j,3)
			{
			  if(fils->v[j] != pere)
			    {
			      if(!P2)
				{
				  P2 = 1;
				  T4 = M_Additiv(mat,pere,fils,i,j); 
				}
			      else
				T5 = M_Additiv(mat,pere,fils,i,j);
			      
			      
			      if(dir1 < 0)
				dir1 = j;
			      else
				dir2 = j;
			    }
			}
		      T6 = M_Additiv(mat,fils,fils,dir1,dir2);	      
		    }
		}
	    }
	  
	  /**/
	  	  
	  first_t = T1 + T5;
	  sec_t = T2 + T4;
	  third_t = T3 + T6;
	  
	  d_sums = (double *)mCalloc(3,sizeof(double));
	  d_sums[0] = first_t;
	  d_sums[1] = sec_t;
	  d_sums[2] = third_t;
	  

	  pere->additiv[dir_fils] = fabs(d_sums[0]-d_sums[1]);
	  
	  free(d_sums);	  

	  
	  if((fabs(T3+T6-T1-T5) < fabs(T2+T4-T1-T5)) || 
	     (fabs(T3+T6-T2-T4) < fabs(T2+T4-T1-T5))) 
	    pere->Wadditiv[dir_fils]=0.75;
	  else
	    pere->Wadditiv[dir_fils]=1;

	  
	  For(i,3)
	    {
	      if(fils->v[i] == pere)
		{
		  fils->additiv[i] = pere->additiv[dir_fils];
		  fils->Wadditiv[i] = pere->Wadditiv[dir_fils];
		}
	    }
	}

      For(i,3)
	if(fils->v[i] != pere)
	  R_Additiv(fils,fils->v[i],mat,tree);
    }
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


double  M_Additiv(matrix *mat, node *pere, node *fils, int Pp, int Pf)
{
  int i,j;
  double val;

  val = 0.0;


 for(i=0;i<pere->n_sons[Pp];i++)
    for(j=0;j<fils->n_sons[Pf];j++)
      val += mat->dist[pere->sons[Pp][i]][fils->sons[Pf][j]];
      
   
  return (val/(pere->n_sons[Pp]*fils->n_sons[Pf])); 
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void Print_Val(node *pere,node *fils,double *add,double *Wsum,int n_otu)
{

  int i;
  

  if(fils->num < n_otu) return;
  
  else
    {
      if(pere->num >= n_otu) 
	{
	  For(i,3)
	    {
	      if(pere->v[i] == fils) 
		{
		  *add += pere->additiv[i];
		  *Wsum += pere->Wadditiv[i];
		}
	    }
	  
	  For(i,3)
	    {
	      if(fils->v[i] != pere)
		Print_Val(fils,fils->v[i],add,Wsum,n_otu); 
	    }
	}
      
      else
	{
	  For(i,3)
	    {
	      if(fils->v[i] != pere)
		Print_Val(fils,fils->v[i],add,Wsum,n_otu);
	    }
	}
    }
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/















