#ifndef BIONJ_H
#define BIONJ_H

#define BL_MIN  .000001

typedef struct __BIONJ_matrix{
  char **names;
  double **dist;
  double **P;
  double **Q;
  int **n_sons;
  int n_spec;
}
bmatrix;

void BIONJ_Print_Mat(bmatrix *mat);
void BIONJ_Initialize(matrix *mat, double **delta, int n, POINTERS *trees);
void BIONJ_Print_output(int i, POINTERS *trees, char *s_tree);
char *Bionj(matrix *mat);
int BIONJ_Symmetrize(double **delta, int n);
void BIONJ_Concatenate(char chain1[100], int ind, POINTERS *trees, int post);
double BIONJ_Distance(int i, int j, double **delta);
double BIONJ_Variance(int i, int j, double **delta);
int BIONJ_Emptied(int i, double **delta);
double BIONJ_Sum_S(int i, double **delta);
void BIONJ_Compute_sums_Sx(double **delta, int n);
void BIONJ_Best_pair(double **delta, int r, int *a, int *b, int n);
double BIONJ_Finish_branch_length(int i, int j, int k, double **delta);
void BIONJ_Finish(double **delta, int n, POINTERS *trees, char *s_tree);
double BIONJ_Agglomerative_criterion(int i, int j, double **delta, int r, int n_otu);
double BIONJ_Branch_length(int a, int b, double **delta, int r);
double BIONJ_Reduction4(int a, double la, int b, double lb, int i, double lamda, double **delta);
double BIONJ_Reduction10(int a, int b, int i, double lamda, double vab, double **delta);
double BIONJ_Lamda(int a, int b, double vab, double **delta, int n, int r);
char *BIONJ_Seq(seq *data, int n_otu);
double BIONJ_Ecart_Relatif_Min(double *tab, int nelem);
int BIONJ_K2PG(seq *data, bmatrix *mat, double g_shape, int n_otu);
int BIONJ_Compute_Dist_K2PG(seq *data, bmatrix *mat, double g_shape, int n_otu);
int BIONJ_CorrectK2PG(bmatrix *mat, double g_shape);
bmatrix *BIONJ_Create_Mat(int n_otu);
void BIONJ_Free_Mat(bmatrix *mat);
void BIONJ_Best_pair_gamma(bmatrix **mat, int r, int *a, int *b, int n, int nalpha);
void BIONJ_Initialize_gamma(bmatrix *mat,double **delta, int n, POINTERS *trees);


#endif






