#include "Generic.h"



/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

char **Sub_Trees(char *tree)
{
  char **subs;
  int pos1,pos2,pos3;
  int i,dec;

  subs=(char **)mCalloc(3,sizeof(char *));

  For(i,3) subs[i]=(char *)mCalloc(strlen(tree),sizeof(char));

  pos1=1;
  if(tree[pos1] != '(')
    {
      while((tree[pos1] != ',' ) && 
	    (tree[pos1] != ':' ))
	pos1++;
      pos1-=1;
    }
  else pos1=Next_Par(tree,pos1);

  Test_Tree(tree+pos1+1);
  strncpy(subs[0],tree+1,pos1);

  pos2=pos1;
  dec=0;
  while(tree[pos2] != ',') 
    {
      pos2++; 
      dec++;
    }
  pos2+=1; dec+=1;

  if(tree[pos2] != '(')
    {
      while(tree[pos2] != ',' && 
	    tree[pos2] != ')' && 
	    tree[pos2] != ':') 
	pos2++;
     pos2-=1;
    }
  else pos2=Next_Par(tree,pos2);

  Test_Tree(tree+pos2+1);
  strncpy(subs[1],tree+pos1+dec,pos2-pos1-dec+1); 
 
  for(;;)
    {
      pos2++;
     
      if(tree[pos2] == ',')
      {
       pos2+=1;
       pos3=pos2;

       if(tree[pos3] != '(')
	{
	  while((tree[pos3] != ':') && 
		(tree[pos3] != ')')) 
	    pos3++;
	 pos3-=1;
	}
       else pos3=Next_Par(tree,pos3);
      
       Test_Tree(tree+pos3+1);
       strncpy(subs[2],tree+pos2,pos3-pos2+1);
       break;
      }

     if(tree[pos2] == ')') 
       {
	 free(subs[2]); 
	 subs[2]=NULL; 
	 break;
       }
    }

  return subs;
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


arbre *Read_Tree(char *s_tree)
{
  char **subs;
  int i;
  char *sub_tp;
  node **noeud;
  arbre *tree;
  int n_ext, n_int,n_otu;

  n_ext=n_int=n_otu=0;

  For(i,(int)strlen(s_tree))
    if(s_tree[i] == ',') n_otu++;

  n_otu+=1;

  subs=Sub_Trees(s_tree);

  if(!subs[2])
    {
      printf("\n ! Unrooted tree is needed ! \n");
      exit(1);
    }

  noeud = (node **)mCalloc(2*n_otu-2,sizeof(node *));

  noeud[n_otu]=(node *)mCalloc(1,sizeof(node));
  Init_Node(noeud[n_otu]);

  noeud[n_otu]->num=n_otu;
  
  sub_tp=(char *)mCalloc(strlen(s_tree),sizeof(char *));

  For(i,3)
    {
      strcpy(sub_tp,subs[i]);
      strcat(sub_tp,":");
      if(strstr(s_tree,sub_tp))
       {
	 noeud[n_otu]->l[i] = atof((char *)strstr(s_tree,sub_tp)
				   +strlen(subs[i])+1);
/*          if(noeud[n_otu]->l[i]<0.0) noeud[n_otu]->l[i] = 0.0; */
       }
    }

  free(sub_tp);

  R_rtree(subs[0],noeud[n_otu],noeud,n_otu,&n_int,&n_ext);
  R_rtree(subs[1],noeud[n_otu],noeud,n_otu,&n_int,&n_ext);
  R_rtree(subs[2],noeud[n_otu],noeud,n_otu,&n_int,&n_ext);

  For(i,3)
    if(subs[i]) free(subs[i]);
  free(subs);

  tree=(arbre *)mCalloc(1,sizeof(arbre));
  tree->n_otu=n_otu;
  Init_Tree(tree,noeud);

  return tree;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void R_rtree(char *s_tree, node *pere, node **noeud, int n_otu, int *n_int, int *n_ext) 
{
  int i;
  char *sub_tp;
  node *fils;


  fils=(node *)mCalloc(1,sizeof(node));
  
  Init_Node(fils);

  if(s_tree[0] == '(')  
    {
      char **subs;
      (*n_int)++;                                  

      noeud[n_otu+(*n_int)]=fils;
      fils->num=n_otu+(*n_int);

      For(i,3)
       {
	 if(pere->v[i] == NULL)
	   {
	     pere->v[i]=fils;
	     fils->l[0]=pere->l[i];
	     break;
	   }
       }
      
      fils->v[0]=pere;                          
      subs=Sub_Trees(s_tree);      
      sub_tp = (char *)mCalloc(strlen(s_tree),sizeof(char));
      strcpy(sub_tp,subs[0]);
      strcat(sub_tp,":");
      if(strstr(s_tree,sub_tp))
	{
	  fils->l[1] = atof((char *)strstr(s_tree,sub_tp)
			    +strlen(subs[0])+1);
	  if(fils->l[1] < 0.0) fils->l[1] = 0.0;
	}
      
      strcpy(sub_tp,subs[1]);
      strcat(sub_tp,":");
      if(strstr(s_tree,sub_tp))
	{
	  fils->l[2] = atof((char *)strstr(s_tree,sub_tp)
			    +strlen(subs[1])+1);
	  if(fils->l[2] < 0.0) fils->l[2] = 0.0;
	}
      
      free(sub_tp);
      R_rtree(subs[0],fils,noeud,n_otu,n_int,n_ext);
      R_rtree(subs[1],fils,noeud,n_otu,n_int,n_ext);
      free(subs[0]); free(subs[1]);
      free(subs);
    } 

  else                                        
    {
      noeud[(*n_ext)]=fils;
  
      For(i,3)
       {
	 if(pere->v[i] == NULL)
	   {
	     pere->v[i]=fils;
	     fils->l[0]=pere->l[i];
	     break;
	   }
       }
      
      fils->v[0]=pere;
      strcpy(fils->name,s_tree); 
      fils->num=(*n_ext);
      (*n_ext)++;
    }
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void Init_Node(node *noeud_func) 
{
  int i;

  noeud_func->v=(node **)mCalloc(3,sizeof(node *));
  noeud_func->arbre_gauche = NULL;
  noeud_func->arbre_droite = NULL;
  noeud_func->b=(branch **)mCalloc(3,sizeof(branch *));
  noeud_func->l=(double *)mCalloc(3,sizeof(double));
  noeud_func->name=(char *)mCalloc(40,sizeof(char));
  noeud_func->additiv=(double *)mCalloc(3,sizeof(double));
  noeud_func->Wadditiv=(double *)mCalloc(3,sizeof(double));
  noeud_func->sons = NULL;

  For(i,3)
    {
      noeud_func->v[i]=NULL;
      noeud_func->b[i]=NULL;
      noeud_func->l[i]=-1;
    }
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

int Next_Par(char *s, int pos)
{
  int curr;
  curr=pos+1;

  while(*(s+curr) != ')')
    {
      if(*(s+curr) == '(') curr=Next_Par(s,curr);
      curr++;
    }

  return curr; 
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void Test_Tree(char *s)
{
  if(*s != ',' && *s != ')' && *s != ':')
    {
      printf("\n ! Tree bad format !\n");
      exit(1);
    }
  return;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void M_Sons(node **noeud, int n_otu)
{
  int i,j,k;

  For(i,2*n_otu-2)
    {
      noeud[i]->n_sons = (int *)mCalloc(3,sizeof(int));
      noeud[i]->sons = (int **)mCalloc(3,sizeof(int *));
      For(j,3)
	{
	  noeud[i]->n_sons[j] = -1;
	  noeud[i]->sons[j] = (int *)mCalloc(n_otu,sizeof(int));
	}
    }
  
  for(i=n_otu;i<2*n_otu-2;i++)
    For(j,3)
      For(k,n_otu) noeud[i]->sons[j][k]=k;
	
  For(i,3)
    R_M_Sons(noeud[n_otu],noeud[n_otu]->v[i],n_otu);
    
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void R_M_Sons(node *pere, node *fils, int n_otu)
{

  int i,j,k,l;
  int pos;
  int dir,cum;
  
  dir = pos = 0;

  if(fils->num < n_otu)
    {
      For(i,3)
	{
	  if(pere->v[i] == fils)
	    {
	      pere->n_sons[i] = 1;
	      pere->sons[i][0] = fils->num;
	    }
	}
      M_Sons_Ext(fils,n_otu);
      return;
    }


  else
    {
      if(pere->num < n_otu)
	{
	  M_Sons_Ext(pere,n_otu);
	  For(i,3)
	    if(fils->v[i] != pere)
	      R_M_Sons(fils,fils->v[i],n_otu); 
	    
	}

      else
       {
	 For(i,3)
	   if(fils->v[i] != pere)
	     R_M_Sons(fils,fils->v[i],n_otu);
	 

	 For(i,3)
	   {
	     if(pere->v[i] == fils)
	       {
		 pere->n_sons[i] = 0;
		 For(j,3)
		   {
		     if(fils->v[j] != pere)
		       {
			 pere->n_sons[i] += fils->n_sons[j];
			 For(k,fils->n_sons[j])
			   {
			     pere->sons[i][pos] = fils->sons[j][k];
			     For(l,3)
			       if(fils->n_sons[l] == -1)
				 fils->sons[l][fils->sons[j][k]] = -1;
			     pos++;
			   }
		       }
		   }
	       }
	   }
       }

      cum = 0;
      For(i,3)
	{
	  if(fils->n_sons[i] == -1)
	    dir = i;
	  else cum += fils->n_sons[i];
	}
      fils->n_sons[dir] = n_otu - cum;
      qsort(fils->sons[dir],(size_t)n_otu,sizeof(int),Tri_Int_Decrois);      
    }    
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void M_Sons_Ext(node *ext, int n_otu)
{
  int i;
  int pos;
     
  pos = 0;

  if(ext->num < n_otu)
    {
      For(i,n_otu)
	{
	  if(i != ext->num)
	    {
	      ext->sons[0][pos] = i;
	      pos++;
	    }
	  else continue;
	}
      
      ext->n_sons[0] = n_otu - 1; 
      ext->n_sons[1] = ext->n_sons[2] = 1;
      ext->sons[1][0] = ext->sons[2][0] = ext->num;
    }
  return; 
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


int Tri_String(const void *a, const void *b)
{
  return(strcmp((*(const char **)(a)), (*(const char **)(b))));
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


int Tri_Int_Decrois(const void *a, const void *b)
{
  if((*(int *)(a)) >= (*(int *)(b))) return -1;
  else return 1;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

int Tri_Double_Decrois(const void *a, const void *b)
{
  if((*(double *)(a)) >= (*(double *)(b))) return -1;
  else return 1;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

int Tri_Int_Crois(const void *a, const void *b)
{
  if((*(int *)(a)) >= (*(int *)(b))) return -1;
  else return 1;
}
/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


int Tri_Double_Crois(const void *a, const void *b)
{
  if((*(double *)(a)) <= (*(double *)(b))) return 1;
  else return -1;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void *mCalloc(int nb, size_t taille)
{
  void *espace_alloue;

  if((espace_alloue = calloc((size_t)nb,taille)) != NULL)
    return espace_alloue;
  
  fprintf(stderr,"\n ! Low Memory !\n\n");
  printf("\a");
  exit(1);
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

void *mRealloc(void *p,int nb, size_t taille)
{

  if((p = realloc(p,(size_t)nb*taille)) != NULL)
    return p;
  
  fprintf(stderr,"\n ! Low Memory !\n");
  printf("\a");
  exit(1);
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void Free_Tree(arbre *tree)
{
  int i;
  int n_otu;

  n_otu = tree->n_otu;

  For(i,2*n_otu-2)
    Free_Noeud(tree->noeuds[i]);

  For(i,2*n_otu-3)
    if(tree->tree_branch[i])
      Free_Branch(tree->tree_branch[i]);
  free(tree->tree_branch);

  free(tree->noeuds);
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

void Free_Branch(branch *edge)
{
  if(edge->bipart) free(edge->bipart);
  free(edge);
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void Free_Noeud(node *noeud)
{
  int i;

  free(noeud->v);

  if(noeud->sons)
    {
      free(noeud->n_sons);
      For(i,3) free(noeud->sons[i]);
      free(noeud->sons);
    }
  
  if(noeud->l) free(noeud->l);
  if(noeud->additiv) free(noeud->additiv);
  if(noeud->Wadditiv) free(noeud->Wadditiv);
  if(noeud->name) free(noeud->name);      
  if(noeud->b) free(noeud->b);
  free(noeud);
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

void Init_Tree(arbre *tree_func,node **noeud_func)
{
  tree_func->noeuds = noeud_func;
  tree_func->tree_branch = 
    (branch **)mCalloc(2*tree_func->n_otu-3,sizeof(branch *));
  tree_func->n_branch_neg=0;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

matrix *Read_Mat(FILE *in)
{

  matrix *tab;
  int i,j;
  int nc;

  tab=(matrix *)mCalloc(1,sizeof(matrix));

  nc = fscanf(in,"%d",&(tab->n_spec));
  if(nc < 0) return NULL;

  tab= (matrix *)Create_Mat(tab->n_spec);
  For(i,tab->n_spec)
    {
      fscanf(in,"%s",tab->names[i]);
      For(j,tab->n_spec)
	fscanf(in,"%lf",&tab->dist[i][j]);
    }
  return tab;
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void M_Order(node **noeud, matrix *mat)
{
  int i,j,k;

  int n_otu;

  n_otu = mat->n_spec;

  For(i,n_otu)
    {
      if(strcmp(mat->names[i],noeud[i]->name))
	{
	  For(j,n_otu)
	    {
	      if(!strcmp(mat->names[j],noeud[i]->name))
		{
		  Echange_String(&mat->names[j],&mat->names[i]);
		  Echange_Vect_Double(&mat->dist[j],&mat->dist[i]);
		  Echange_Vect_Double(&mat->P[j],&mat->P[i]);
		  Echange_Vect_Double(&mat->Q[j],&mat->Q[i]);

		  For(k,n_otu)
		    {
		      Echange_Elem_Double(&mat->dist[k][j],&mat->dist[k][i]);
		      Echange_Elem_Double(&mat->P[k][j],&mat->P[k][i]);
		      Echange_Elem_Double(&mat->Q[k][j],&mat->Q[k][i]);
		    }
		  break;
		}
	    }
	}
    }
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

void Echange_String(char **a, char **b)
{
  char *buff = NULL;
  buff=*a;
  *a=*b;
  *b=buff;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

void Echange_Vect_Double(double **a, double **b)
{
  double *buff = NULL;
  buff=*a;
  *a=*b;
  *b=buff;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

void Echange_Elem_Double(double *a, double *b)
{
  double buff = 0.0;
  buff=*a;
  *a=*b;
  *b=buff;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

void Print_Mat(matrix *mat)
{
  int i,j;
 
  printf("    %d",mat->n_spec);  
  printf("\n");

  For(i,mat->n_spec)
    {
      if(i<mat->n_spec) printf("%s  ",mat->names[i]);
      else printf("    ");
      For(j,mat->n_spec)
	{
	  if(mat->dist[i][j] == -1)
	    printf("   -     ");
	  else
	    printf("%f  ",mat->dist[i][j]);
	}
      printf("\n");
    }
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/
   
seq *Read_Seq_Sequential(FILE *in, int *n_otu)
{
  int i, position;
  char *line;
  double len;
  seq *data;

  line = (char *)mCalloc(T_MAX_LINE,sizeof(char));

  if((fscanf(in,"%s",line)) != EOF);
  else 
    {
      free(line);
      return NULL;
    }
  
  *n_otu = atoi(line);

  data = (seq *)mCalloc(*n_otu,sizeof(seq));

  fscanf(in,"%s",line);
  len = atoi(line);

  For(i,*n_otu)
    {
      data[i].len = 0;
      data[i].name = (char *)mCalloc(T_MAX_NAME,sizeof(char));
      data[i].base = (char *)mCalloc(T_MAX_SEQ,sizeof(char));
      fscanf(in,"%s",data[i].name);
      position = 0;
      
      while(data[i].len < len)
	Read_One_Line_Seq(data,i,&position,in);
      
      if(data[i].len > len) 
	{
	  printf(" Problem with species %s's sequence\n",data[i].name);
	  exit(1);
	}
    }
  free(line);
  return data;
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


seq *Read_Seq_Interleaved(FILE *in, int *n_otu)
{
  int i,position;
  char *line;
  double len;
  seq *data;

  line = (char *)mCalloc(T_MAX_LINE,sizeof(char));

  if((fscanf(in,"%s",line)) != EOF);
  else 
    {
      free(line);
      return NULL;
    }
  
  *n_otu = atoi(line);

  data = (seq *)mCalloc(*n_otu,sizeof(seq));

  fscanf(in,"%s",line);
  len = atoi(line);
  free(line);

  For(i,*n_otu)
    {
      data[i].len = 0;
      data[i].name = (char *)mCalloc(T_MAX_NAME,sizeof(char));
      data[i].base = (char *)mCalloc(T_MAX_SEQ,sizeof(char));
      fscanf(in,"%s",data[i].name);
      position = 0;
      Read_One_Line_Seq(data,i,&position,in);
    }


  while(1)
    {
      For(i,*n_otu)
	{
	  if(data[i].len > len) 
	    {
	      printf(" Problem with %s's sequence\n",data[i].name);
	      exit(1);
	    }
	  if(data[i].len == len) {return data;}
	  position = (int)(strlen(data[i].name)+1);
	  if(!Read_One_Line_Seq(data,i,&position,in)) break;
	}
    }
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


int Read_One_Line_Seq(seq *data, int num_otu, int *position, FILE *in)
{
  char c;
  int depart;

  depart = 0;
  while(depart++ != *position) 
    {
      c = (char)fgetc(in);
      if(c == EOF) return 0;
    }

  while(1)
    {
      c = (char)fgetc(in);
      if((c != '\n') && (c != ' ') && (c != '\t')) break;
    }

  while(1)
    {
      if((c == EOF) || (c == '\n')) break;
      else if((c == ' ') || (c == '\t')) { c = (char)fgetc(in); continue;}
      Uppercase(&c);
      if (strchr("ABCDGHKMNRSTUVWXY?O-.",c) == NULL)
	{
	  printf("Error: bad symbol: \"%c\" at position %d of species %s\n",
		 c,data[num_otu].len,data[num_otu].name);
	  exit(-1);
	}

      if(c == '.')
	{
	  c = data[0].base[data[num_otu].len];
	  if(!num_otu) 
	    {
	      printf("Symbol \".\" is should not appear in the first sequence\n");
	      exit(-1);
	    }
	}
      data[num_otu].base[data[num_otu].len] = c;
      (*position)++;
      data[num_otu].len++;
      c = (char)fgetc(in);
    }
  if(c == EOF) return 0;
  else return 1;
}



/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/
   

void Free_Seq(seq *Data, int n_spec)
{
  int i;
  For(i,n_spec)
    {
      free(Data[i].name);
      free(Data[i].base);
    }
  free(Data);
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void Free_Mat(matrix *mat)
{
  int i,n_otu;

  n_otu = mat->n_spec;  

  For(i,n_otu)
    {
      if(mat->names[i])
	free(mat->names[i]); 
      free(mat->P[i]);
      free(mat->Q[i]);
      free(mat->dist[i]);
      free(mat->n_sons[i]);
    }

  if(mat->names)
    free(mat->names);
  free(mat->dist);
  free(mat->n_sons);
  free(mat->P);
  free(mat->Q);
  free(mat);
}



/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


double TreeBl(arbre *tree)
{
  double T = 0.0;
  R_TreeBl(tree->noeuds[0],tree->noeuds[0]->v[0],&T,tree->n_otu);
  return T;
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void R_TreeBl(node *pere, node *fils,double *T, int n_otu)
{
  int i;

  if(fils->num < n_otu)
    {
      *T += fabs(fils->l[0]);
      return;
    }

  else
    {
      For(i,3)
	{
	  if(fils->v[i] == pere) *T += fabs(fils->l[i]);
	  else
	    R_TreeBl(fils,fils->v[i],T,n_otu);
	}
    }
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void Init_Mat(matrix *mat)
{
  int i,j,n_otu;
  n_otu = mat->n_spec;
  For(i,n_otu)
    For(j,n_otu)
    mat->n_sons[i][j] = 1;
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


matrix *Create_Mat(int n_otu)
{
  int i;
  matrix *mat;

  (mat) = (matrix *)mCalloc(1,sizeof(matrix));
  (mat)->n_spec = n_otu;
  (mat)->dist = (double **)mCalloc(n_otu,sizeof(double *));
  (mat)->P = (double **)mCalloc(n_otu,sizeof(double *));
  (mat)->Q = (double **)mCalloc(n_otu,sizeof(double *));
  (mat)->n_sons = (int **)mCalloc(n_otu,sizeof(int *));
  (mat)->names = (char **)mCalloc(n_otu,sizeof(char *));
  For(i,n_otu)
    {
      (mat)->dist[i] = (double *)mCalloc(n_otu,sizeof(double));
      (mat)->n_sons[i] = (int *)mCalloc(n_otu,sizeof(int));
      (mat)->P[i] = (double *)mCalloc(n_otu,sizeof(double));
      (mat)->Q[i] = (double *)mCalloc(n_otu,sizeof(double));  
      (mat)->names[i] = (char *)mCalloc(T_MAX_NAME,sizeof(char));
    }
  return mat;
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

double **Lbranch2Dist(arbre *tree)
{
  int i,j;
  double **dist;
  int n_otu;

  n_otu = tree->n_otu;

  dist=(double **)mCalloc(n_otu,sizeof(double *));

  For(i,n_otu)
    dist[i]=(double *)mCalloc(n_otu,sizeof(double));

  if(!(tree->noeuds[0]->sons))
    M_Sons(tree->noeuds,n_otu);

  For(i,3)
    R_m_dist(tree->noeuds[0]->v[0],tree->noeuds[0]->v[0]->v[i],dist,n_otu);

  For(i,n_otu)
   {
     For(j,n_otu)     
       {
	 if(j > i) dist[i][j] += dist[j][i];
	 else dist[i][j] = dist[j][i];
       }
   }

  /* Norme */
/*    T = 0.0; */
/*    For(i,n_otu) */
/*      { */
/*        for(j=i;j<n_otu;j++) */
/*  	{ */
/*  	  T += dist[i][j]; */
/*  	} */
/*      } */

/*    For(i,n_otu) */
/*      { */
/*        For(j,n_otu) */
/*  	{ */
/*  	  dist[i][j] /= T; */
/*  	} */
/*      } */

  return dist;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void R_m_dist(node *pere, node *fils, double **dist, int n_otu)
{

  int i,j;
  int dir_pere, dir_fils;

  dir_pere = dir_fils = -1;

  if(fils->num < n_otu)
    {
      For(i,n_otu)
	{
	  if(i != fils->num)
	    dist[fils->num][i]+=fils->l[0];
	}
      return;
    }

  else
    {
      For(i,3)
	{
	  if(pere->v[i] == fils) dir_fils = i;
	  if(fils->v[i] == pere) dir_pere = i;
	}
      
      For(i,fils->n_sons[dir_pere])
	For(j,pere->n_sons[dir_fils])
	dist[fils->sons[dir_pere][i]][pere->sons[dir_fils][j]] += fils->l[dir_pere];
	    
      For(i,3)
	if(i != dir_pere)
	  R_m_dist(fils,fils->v[i],dist,n_otu);
	   
    }
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


char *Write_Tree(arbre *tree)
{

  char *s;
  int i,j;

  s=(char *)mCalloc(T_MAX_LINE,sizeof(char));
  
  
  s[0]='(';
  
  for(i=tree->n_otu;i<2*(tree->n_otu)-2;i++)
    {
      For(j,3)
	R_wtree(tree->noeuds[i],tree->noeuds[i]->v[j],s,tree->n_otu);
      break;
    }

  s[(int)strlen(s)-1]=')';
  s[(int)strlen(s)]=';';
  
  
  return s;;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void R_wtree(node *pere,node *fils,char *s_tree,int n_otu)
{

  if(fils->num < n_otu) 
    {
      strcat(s_tree,fils->name);
      if(fils->l[0] != -1)
	{
	  strcat(s_tree,":");
	  sprintf(s_tree+(int)strlen(s_tree),"0.1");
	  /*sprintf(s_tree+(int)strlen(s_tree),"%f",fils->l[0]);*/
	}
    }

  else
    {
      int i,p;
      s_tree[(int)strlen(s_tree)]='(';
      For(i,3)
	{
	  if(fils->v[i] != pere)
	    R_wtree(fils,fils->v[i],s_tree,n_otu);
	  else p=i;
	}	
      s_tree[(int)strlen(s_tree)-1]=')';
      if(fils->l[0] != -1)
	{
	  strcat(s_tree,":");
	  /*sprintf(s_tree+(int)strlen(s_tree),"%f",fils->l[p]);*/
	  sprintf(s_tree+(int)strlen(s_tree),"0.1");
	}
    }
  strcat(s_tree,",");
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


arbre *Copy_Tree(arbre *original)
{

  arbre *copie;
  int n_otu;
  int i,j,k;

  n_otu = original->n_otu;
  copie = (arbre *)mCalloc(1,sizeof(arbre));
  copie->n_otu = n_otu;
  copie->noeuds = (node **)mCalloc(2*n_otu-2,sizeof(node *));
  copie->tree_branch = (branch **)mCalloc(2*n_otu-3,sizeof(branch *));

  For(i,2*n_otu-2)
    {
      copie->noeuds[i] = (node *)mCalloc(1,sizeof(node));
      Init_Node(copie->noeuds[i]);
      copie->noeuds[i]->num = original->noeuds[i]->num;
    }

  For(i,2*n_otu-2)
    {
      For(j,3)
	{	      	      	  
	  /*printf(">%d\n",original->noeuds[i]->v[j]->num);*/
	  if(original->noeuds[i]->v[j])
	    {
	      copie->noeuds[i]->l[j] = original->noeuds[i]->l[j];
	      copie->noeuds[i]->v[j] = 
		copie->noeuds[original->noeuds[i]->v[j]->num];	  
	      
	      if(original->noeuds[i]->b[j])
		{
		  copie->noeuds[i]->b[j] = 
		    (branch *)mCalloc(1,sizeof(branch));
		  copie->noeuds[i]->b[j]->boutg = 
		    copie->noeuds[original->noeuds[i]->b[j]->boutg->num];
		  copie->noeuds[i]->b[j]->boutd = 
		    copie->noeuds[original->noeuds[i]->b[j]->boutd->num];
		  if(original->noeuds[i]->b[j]->bipart)
		    {
		      copie->noeuds[i]->b[j]->bipart = 
			(node **)mCalloc(original->noeuds[i]->b[j]->n_bipart,sizeof(node *));
		      copie->noeuds[i]->b[j]->n_bipart = 
			original->noeuds[i]->b[j]->n_bipart;
		      For(k,original->noeuds[i]->b[j]->n_bipart)
			copie->noeuds[i]->b[j]->bipart[k] = 
			copie->noeuds[original->noeuds[i]->b[j]->bipart[k]->num];
		    }
		}
	    }
	  else
	    copie->noeuds[i]->v[j] = NULL;
	}
    }
  
  R_tree_branch(copie->noeuds[0],copie->noeuds[0]->v[0],copie);

  For(i,n_otu)
    strcpy(copie->noeuds[i]->name,original->noeuds[i]->name);

  return copie;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

void Init_Branch(branch *edge_func)
{
  edge_func->bipart=NULL;
  edge_func->depth=0;
  edge_func->common=0;
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void R_tree_branch(node *pere,node *fils, arbre *tree)
{
  int i;

  if(!fils) return;

  For(i,3)
    {
      if(fils->v[i] == pere)
      {
	tree->n_branch++;
	tree->tree_branch[tree->n_branch-1]=fils->b[i];
      }

      else
	R_tree_branch(fils,fils->v[i],tree);
    }
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void Norm_Mat(matrix *mat, double normeur)
{
  double T,TT;
  int i,j,n_elem;

  n_elem = mat->n_spec*(mat->n_spec-1)/2;
  T = 0.0;
  TT = 0.0;
  For(i,mat->n_spec)
    {
      for(j=i+1;j<mat->n_spec;j++)
      {
	T += mat->dist[i][j];
	TT += pow(mat->dist[i][j],2);
      }
    }

  TT = TT/n_elem - pow(T/n_elem,2);

  For(i,mat->n_spec)
    {
      for(j=i+1;j<mat->n_spec;j++)
	{
	  mat->dist[i][j] *= normeur;
	  mat->dist[i][j] /= pow(T,1);
/*  	  mat->dist[i][j] /= sqrt(TT); */
	  mat->dist[j][i] = mat->dist[i][j];
	}
    } 
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/



void Print_Seq(seq *data, int n_otu)
{

  int i,j;

  printf("%d\t%d\n",n_otu,data[0].len);

  For(i,n_otu)
    {
      printf("%s\t",data[i].name);
      
      For(j,data[i].len)
	printf("%c",data[i].base[j]);
      
      printf("\n");
    }
}


/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

int Pos_Min(double *tab, int n_elem)
{

  int cur, pos;
  double min;

  min = 100000;
  pos = 0;

  For(cur,n_elem)
    {
      if((tab[cur] < min) && (tab[cur] >= 0.0))
	{
	  min = tab[cur];
	  pos = cur;
	}
    }

  return pos;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


void Uppercase(char *ch)
{
  /* convert ch to upper case -- either ASCII or EBCDIC */
   *ch = isupper(*ch) ? *ch : toupper(*ch);
}
