#include "Generic.h"
#include "Read_In.h"
#define ibmpc0          false
#define ansi0           true
#define vt520           false

option *Get_Options()
{
  char ch;
  option *opt;
  int kimura,jukes;
  char *name;

  name = (char *)mCalloc(T_MAX_FILE,sizeof(char));

  opt = (option *)mCalloc(1,sizeof(option));

  opt->interleaved = 1;
  opt->fixed       = 0;
  kimura           = 1;
  jukes            = 0;
  opt->model       = 1;
  opt->mult        = 0;
  opt->each        = 1;
  opt->otree       = 0;
  opt->format      = 0;
  opt->in_alpha    = NULL;

  printf("\n");
  for(;;)
    {      
      printf("\033[2J\033[H");
      printf(" ********************************************************* \n");
      printf(" Option (a) : the input file  contains  one or several DNA \n");
      printf(" sequences data set(s) \n");
      printf(" Option (b) : the input file  contains  distance  matrices \n");
      printf(" computed with PROTphylip.pl or DNAphylip.pl\n");
      printf(" ********************************************************* \n");
      printf("\n");
      printf(" Data  set  format  (distances matrices / DNA  sequences)?  %s\n",
	     (opt->format ? "distances" : "sequences"));
      printf("\n Type Y or C to change ");	fflush(stdout);	/* ++pac */
      scanf("%c", &ch);
      Uppercase(&ch);
      if (ch == 'Y')
	break;

      if (strchr("C",ch) != NULL)
	{
	  switch(ch)
	    {
	    case 'C' :
	      {
		opt->format = !(opt->format);
		break;
	      }
	    }
	}

    }

  for(;;)
    {

      printf("\033[2J\033[H");
      

      printf(" [GAMMA] \n\n");

      if((!opt->format) && (!opt->fixed))
	{
	  printf(" ********************************************************* \n");
	  printf(" You analyze DNA sequences.  The default  option is to use \n");
	  printf(" alpha* to build the tree(s). But you can instead use your \n");
	  printf(" own  value  using  option  A.  When alpha* is chosen, the \n");
	  printf(" default  option is to select its value from a default set \n");
	  printf(" included  in  the  program. But a different  set  can  be \n");
	  printf(" tested  using  option  V. In this way,  you  can focus on \n");
	  printf(" particular values, or save computing time by testing less \n");
	  printf(" values than  when using the default set.\n");
	  printf(" ********************************************************* \n");
          fflush(stdout);	/* ++pac */
	}

      if((!opt->format) && (opt->fixed))
	{
	  printf(" ********************************************************* \n");
	  printf(" The tree will be build using a single user defined value. \n");
	  printf(" ********************************************************* \n");	fflush(stdout);	/* ++pac */
	}

      if(opt->format)
	{
	  printf(" ********************************************************* \n");
	  printf(" The input  file  is  a  distance matrices file,  obtained \n");
	  printf(" from DNAphylip.pl or PROTphylip.pl.                       \n");
	  printf(" You  have  to  tell  (option V) the  program which values \n"); 
	  printf(" of alpha have been  used to build the matrices, i.e., the \n");
	  printf(" default values included in DNAphylip.pl or PROTphylip.pl, \n");
	  printf(" or your own values.                                       \n");
	  printf(" ********************************************************* \n");
	}


      printf("\n\n");	fflush(stdout);	/* ++pac */

      if(opt->format)
	{
      printf(" V                 Values of alpha (default/user defined)?  %s",
		 (opt->in_alpha ? "user defined" : "default")); 	fflush(stdout);	/* ++pac */
	}
      else
	{
      printf(" M                             Analyze multiple data sets?  %s\n",
		 (opt->mult ? "yes" : "no"));	fflush(stdout);	/* ++pac */
	  
	  
      printf(" A  Alpha used to build the tree(s) (alpha*/user defined)?  %s",
		 (opt->fixed ?  "" : "alpha*"));	fflush(stdout);	/* ++pac */
	  
	  if(opt->fixed) printf("alpha=%5.3f\n",opt->f_alpha);
	  else printf("\n");
	fflush(stdout);	/* ++pac */
	  if(!opt->fixed)
	    {
      printf(" V    Values of alpha to be tested (default/user defined)?  %s\n",
		     (opt->in_alpha ? "user defined" : "default"));	fflush(stdout);	/* ++pac */
	    }

	  if(opt->mult)
	    {
	      if(!opt->fixed)
		{
      printf(" E  Compute alpha* value for (all, the first) data set(s)?  %s\n",
			 (opt->each ? "all" : "first"));	fflush(stdout);	/* ++pac */
		}
	    }
	  
      printf(" D                                Distance (Kimura, JC69)?  %s\n",
		 kimura ? "Kimura 2-parameters" :
		 jukes  ? "Jukes-Cantor"       : "Kimura 2-parameters");	fflush(stdout);	/* ++pac */
	  
      printf(" I                            Input sequences interleaved?  %s ",
		 opt->interleaved ? "yes" : "no, sequential");	fflush(stdout);	/* ++pac */
	}
      printf("\n\n Are these settings correct? (type Y or the letter for one to change)\n ");	fflush(stdout);	/* ++pac */
 	
      scanf("%c", &ch);
      Uppercase(&ch);
      if (ch == 'Y')
	break;

      if (strchr("MAEDIV",ch) != NULL)
	{
	  switch(ch)
	    {

	    case 'M' : 
	      {
		opt->mult = !(opt->mult);
		break;
	      }
	    case 'A' : 
	      {
		opt->fixed = !(opt->fixed);
		if(opt->fixed)
		  {
		    char *a;
		    a = (char *)mCalloc(T_MAX_LINE,sizeof(char));
		    printf(" Value of alpha? ");	fflush(stdout);	/* ++pac */
		    scanf("%s",a);	    
		    while((!atof(a)) || (atof(a) < .0))
		      {
			printf(" alpha should be a positive number\n");
			printf(" Value of alpha? ");	fflush(stdout);	/* ++pac */
			scanf("%s",a);
		      }
		    opt->f_alpha = (double)atof(a);
		    opt->each = 0;
		    free(a);
		  }
		break;
	      }
	      
	    case 'V' :
		{
		  if(opt->in_alpha) opt->in_alpha = NULL;
		  else
		    {
		      printf(" Name of the file which contains your values of alpha : ");	fflush(stdout);	/* ++pac */
		      scanf("%s",name);
		      while(!(opt->in_alpha = fopen(name,"r")))
			{
			  printf(" Can't find file \"%s\"\n",name);
			  printf(" Please enter a new file name> ");	fflush(stdout);	/* ++pac */
			  scanf("%s",name);
			}
		    }
		  break;
		}
	    case 'E' :
	      {
		opt->each = !(opt->each);
		break;
	      }
	    case 'D' :
	      {
		if(kimura) 
		  {
		    opt->model = 0;
		    kimura = 0;
		    jukes = 1;
		  } 
		else if (jukes) 
		  {
		    opt->model = 1;
		    jukes = 0;
		    kimura = 1;
		  }
		break;
	      }

	    case 'I' :
	      {
		opt->interleaved = !(opt->interleaved);
		break;
	      }
	    
	    default : 
	      {
		break;
	      }
	    }
	}
    }
  free(name);
  return opt;
}
  
/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/


/* Sequence reading */

seq *Get_Seq(FILE *fseq, int *n_otu, option *opt)
{
  seq *data;
  if(opt->interleaved) data = Read_Seq_Interleaved(fseq,n_otu);
  else data = Read_Seq_Sequential(fseq,n_otu);
  return data;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/

double *Get_Alpha(option *opt)
{
  double *alpha,val;
  int i;

  if(!opt->in_alpha)
    {
      alpha = (double *)mCalloc(223,sizeof(double));
      
      val = .06;
      For(i,147)
	{
	  alpha[i] = val;
	  val += .02;
	}
      
      for(i=147;i<217;i++) 
	{
	  alpha[i] = val;
	  val += 0.1;
	}
      alpha[217] = 50.0;
      alpha[218] = 100.0;
      alpha[219] = 500.0;
      alpha[220] = 1000.0;
      alpha[221] = 5000.0;
      alpha[222] = -1.0;
    }
  else
    {
      printf("Reading your values of alpha...\n");
      alpha = (double *)mCalloc(T_MAX_ALPHA,sizeof(double));
      i = 0;
      while(fscanf(opt->in_alpha,"%lf",alpha+i) != EOF) 
	{
	  if(alpha[i] < .06)
	    {
	      printf("Values of alpha should be > 0.06 ! \n");
	      exit(-1);
	    }
	  i++;
	  if(i>T_MAX_ALPHA)
	    {
	      printf("There should be no more than 500 values in the file\n");
	      exit(-1);
	    }	      
	};
      alpha[i] = -1.0;
      fclose(opt->in_alpha);
    }
  return alpha;
}

/*:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:!:*/




